(defun 1+ (x)
  (+ x 1))

(defun 1- (x)
  (- x 1))

(defun zerop (x)
  (if (= x 0) t nil))

(defun cadr (x)
  (car (cdr x)))

(defun cddr (x)
  (cdr (cdr x)))

(defun equal (x y)
  (or (and (atom x) (atom y) (eq x y))
    (and (not (atom x)) (not (atom y))
         (equal (car x) (car y)) (equal (cdr x) (cdr y)))))

(defun append (x y)
  (cond
    ((not x) y)
    (t (cons (car x) (append (cdr x) y))) ))

(defun remove (e l)
  (cond
    ((not l) nil)
    ((equal e (car l)) (remove e (cdr l)))
    (t (cons (car l) (remove e (cdr l)))) ))

(defun nth (n l)
  (cond
    ((atom l) l)
    ((eq n 0) (car l))
    (t (nth (- n 1) (cdr l)))))

(defun count (l)
  (cond
    ((eq l nil)	0)
    ((atom l)	1)
    (t (+ (count (car l)) (count (cdr l)))) ))

