(defun put-c (x)				;; print char
  (U 0x200 x))

(defun put-i (x)				;; print identifier
  (U 0x201 x))

(defun put-l (x)				;; print "string"
  (when x
    (put-c (car x))
    (put-l (cdr x)) ))

(defun terpri nil
  (put-c 10))	

(defun put-d (x)				;; print decimal number
  (if (< x 0)
    (progn
      (put-c #-)
      (put-d (- 0 x)))
    ((lambda (x1)
      (when (< 0 x1)
        (put-d x1))
      (put-c (+ (% x 10) #0))) (/ x 10)) ))

(defun _print (x)
  (cond
    ((atom x)
      (cond
        ((eq x nil) (put-l "nil"))
        ((eq x t)   (put-l "t"))
        ((intp x)   (put-d x))
	(t          (put-i x))))
    (t
      (put-c 0x28)				;; '('
      (while x
        (_print (car x))
        (when (setq x (cdr x))
          (put-c 0x20)) )			;; ' '
      (put-c 0x29)) ))				;; ')'
(defun print (x)
  (_print x)
  (terpri)
  x)
